package com.ruoyi.common.constant;

/**
 * 缓存的key 常量
 *
 * @author ruoyi
 */
public class CacheConstants
{
    /**
     * 登录用户 redis key
     */
    public static final String LOGIN_TOKEN_KEY = "login_tokens:";

    /**
     * 验证码 redis key
     */
    public static final String CAPTCHA_CODE_KEY = "captcha_codes:";

    /**
     * 参数管理 cache key
     */
    public static final String SYS_CONFIG_KEY = "sys_config:";

    /**
     * 字典管理 cache key
     */
    public static final String SYS_DICT_KEY = "sys_dict:";

    /**
     * 防重提交 redis key
     */
    public static final String REPEAT_SUBMIT_KEY = "repeat_submit:";

    /**
     * 活体检测Token
     */
    public static final String LIVENESS_TOKEN = "liveness:";

    /**
     * 限流 redis key
     */
    public static final String RATE_LIMIT_KEY = "rate_limit:";

    /**
     * 登录账户密码错误次数 redis key
     */
    public static final String PWD_ERR_CNT_KEY = "pwd_err_cnt:";
    /**
     * 微信access_token
     */
    public static final String WX_ACCESS_TOKEN = "wx_access_token:";
    /**
     * 项目名称列表
     */
    public static final String PROJECT_NAME_LIST = "project_name_list";
    /**
     * 用户名称列表
     */
    public static final String USER_NAME_LIST = "user_name_list";
    /**
     * 部门名称列表
     */
    public static final String DEPT_NAME_LIST = "dept_name_list";
    /**
     * 资源分类名称列表
     */
    public static final String ATTACH_CLASSIFY_NAME_LIST = "attach_classify_name_list";
    /**
     * websocket用户session
     */
    public static final String WS_USER_SESSION = "ws_user_session:";
    /**
     * 所有应用列表
     */
    public static final String ALL_APP_LIST = "all_app_list";
    /**
     * 所有渠道列表
     */
    public static final String CHANNEL_NAME_LIST = "channel_name_list";
    /**
     * 设备在线状态
     */
    public static final String DEVICE_ONLINE_STATUS = "device_online_status:";
    /**
     * 设备离线计数
     */
    public static final String DEVICE_OFFLINE_INCREMENT = "device_offline_increment:";

    /**
     * 定位日志队列
     */
    public static final String LOCATION_LOG_QUEUE = "location_log_queue";
    /**
     * 待插入的命令日志
     */
    public static final String INSERT_COMMAND_LOG = "insert_command_log";

    /**
     * 运营区禁行区列表
     */
    public static final String NO_RIDING_AREA_SUB_LIST = "no_riding_area_sub_list:";
    /**
     * 运营区停车区列表
     */
    public static final String PARKING_AREA_SUB_LIST = "parking_area_sub_list:";
    /**
     * 运营区禁停区列表
     */
    public static final String NO_PARKING_AREA_SUB_LIST = "no_parking_area_sub_list:";

    /**
     * 设备运营区处理状态
     */
    public static final String DEVICE_AREA_HANDLE_KEY = "device_area_handle_key:";
    /**
     * 所有硬件版本名称
     */
    public static final String ALL_HARDWARE_VERSION_NAME = "all_hardware_version_name";
}
