package com.ruoyi.common.valid.face;

import com.alibaba.fastjson2.annotation.JSONField;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @author wjh
 * 2024/9/20
 */
@Data
public class FaceResponseData {

    @JSONField(name = "order_no")
    private String orderNo;

    //score 比较结果分值，0-1之间的小数，参考指标：0.40以下系统判断为不同人；0.40-0.45不能确定是否为同一人；0.45以上系统判断为同一人
    private BigDecimal score;

    private String msg;

    /**
     * incorrect详解
     *   1、编号说明
     *     100 比对成功，还要根据score的值来判断是否同一人
     *     101 身份证号码姓名不一致
     *     102 库中无此号
     *     103 身份核验成功，数据非法，公安已经进行了身份核验（姓名身份证号码一致，公安返回的错误: 除库中无照片（109），特征提取失败（110），检测到多于一张人脸(111)，人脸识别系统异常(106)，图片不合法(112)以外的情况
     *     104 数据非法，公安未进行身份核验前图片校验，公安返回的错误: 除照片质量不合格(107)，上传图片文件过大(108)，人像比对服务异常(113)以外的情况
     *     106 身份核验成功，人脸识别系统异常
     *     107 照片质量不合格
     *     108 上传图片文件过大
     *     109 身份核验成功，库中无照片
     *     110 身份核验成功，特征提取失败
     *     111 身份核验成功，检测到多于一张人脸
     *     112 身份核验成功，图片不合法
     *     113 人像比对服务异常
     *     103 身份核验成功，数据非法
     *
     *   2、103，104区别
     *     103证件号码一致，照片比对时报错；104未进行证件号校验，数据检验报错。
     *
     *   3、104，107区别
     *     107检测到的公安错误；104未检测到的公安错误
     */
    private Integer incorrect;

}
