package com.ruoyi.bst.agreement.domain;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 协议列表对象 bst_agreement
 *
 * @author ruoyi
 * @date 2025-05-14
 */
@Data
public class Agreement extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "APPID")
    @ApiModelProperty("APPID")
    @NotNull(message = "APPID不能为空",groups = {ValidGroup.Create.class})
    private Long appId;

    @Excel(name = "标题")
    @ApiModelProperty("标题")
    @NotBlank(message = "协议标题不能为空",groups = {ValidGroup.Create.class})
    private String title;

    @Excel(name = "内容详情")
    @ApiModelProperty("内容详情")
    @NotBlank(message = "协议内容不能为空",groups = {ValidGroup.Create.class})
    private String content;

    @Excel(name = "协议类型:1-用户协议 2-隐私政策 3-关于我们 4-服务协议")
    @ApiModelProperty("协议类型:1-用户协议 2-隐私政策 3-关于我们 4-服务协议")
    @NotBlank(message = "协议类型不能为空",groups = {ValidGroup.Create.class})
    private String agreementType;

}
