package com.ruoyi.bst.articleCategory.service;

import com.ruoyi.bst.articleCategory.domain.ArticleCategory;
import com.ruoyi.bst.articleCategory.domain.ArticleCategoryQuery;
import com.ruoyi.bst.articleCategory.domain.ArticleCategoryVO;

import java.util.List;

/**
 * 文章分类Service接口
 *
 * @author ruoyi
 * @date 2025-03-27
 */
public interface ArticleCategoryService
{
    /**
     * 查询文章分类
     *
     * @param id 文章分类主键
     * @return 文章分类
     */
    public ArticleCategoryVO selectArticleCategoryById(Long id);

    /**
     * 查询文章分类列表
     *
     * @param articleCategoryQuery 文章分类
     * @return 文章分类集合
     */
    public List<ArticleCategoryVO> selectArticleCategoryList(ArticleCategoryQuery articleCategoryQuery);

    /**
     * 新增文章分类
     *
     * @param articleCategory 文章分类F
     * @return 结果
     */
    public int insertArticleCategory(ArticleCategory articleCategory);

    /**
     * 修改文章分类
     *
     * @param articleCategory 文章分类
     * @return 结果
     */
    public int updateArticleCategory(ArticleCategory articleCategory);


    /**
     * 删除文章分类信息
     *
     * @param id 文章分类主键
     * @return 结果
     */
    public int deleteArticleCategoryById(Long id);

}
