package com.ruoyi.bst.balanceLog.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 余额日志对象 bst_balance_log
 *
 * @author ruoyi
 * @date 2025-03-14
 */
@Data
public class BalanceLog extends BaseEntity {
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "用户ID")
    @ApiModelProperty("用户ID")
    private Long userId;

    @Excel(name = "变动金额")
    @ApiModelProperty("变动金额")
    private BigDecimal amount;

    @Excel(name = "变动前余额")
    @ApiModelProperty("变动前余额")
    private BigDecimal beforeBalance;

    @Excel(name = "变动后余额")
    @ApiModelProperty("变动后余额")
    private BigDecimal afterBalance;

    @Excel(name = "业务类型")
    @ApiModelProperty("业务类型")
    private String bstType;

    @Excel(name = "业务ID")
    @ApiModelProperty("业务ID")
    private Long bstId;

    @Excel(name = "变动原因")
    @ApiModelProperty("变动原因")
    private String reason;

}
