package com.ruoyi.bst.bindRecord.service;

import java.util.List;
import com.ruoyi.bst.bindRecord.domain.BindRecord;
import com.ruoyi.bst.bindRecord.domain.BindRecordVO;
import com.ruoyi.bst.bindRecord.domain.BindRecordQuery;
import com.ruoyi.bst.bindRecord.domain.enums.BindRecordType;

/**
 * 设备绑定记录Service接口
 *
 * @author ruoyi
 * @date 2025-04-24
 */
public interface BindRecordService
{
    /**
     * 查询设备绑定记录
     *
     * @param recordId 设备绑定记录主键
     * @return 设备绑定记录
     */
    public BindRecordVO selectBindRecordByRecordId(Long recordId);

    /**
     * 查询设备绑定记录列表
     *
     * @param bindRecord 设备绑定记录
     * @return 设备绑定记录集合
     */
    public List<BindRecordVO> selectBindRecordList(BindRecordQuery bindRecord);

    /**
     * 新增设备绑定记录
     *
     * @param bindRecord 设备绑定记录
     * @return 结果
     */
    public int insertBindRecord(BindRecord bindRecord);

    /**
     * 修改设备绑定记录
     *
     * @param bindRecord 设备绑定记录
     * @return 结果
     */
    public int updateBindRecord(BindRecord bindRecord);

    /**
     * 批量删除设备绑定记录
     *
     * @param recordIds 需要删除的设备绑定记录主键集合
     * @return 结果
     */
    public int deleteBindRecordByRecordIds(Long[] recordIds);

    /**
     * 删除设备绑定记录信息
     *
     * @param recordId 设备绑定记录主键
     * @return 结果
     */
    public int deleteBindRecordByRecordId(Long recordId);


    /**
     * 绑定记录
     */
    int record(Long userId, Long deviceId, BindRecordType recordType);

}
