package com.ruoyi.bst.booth.domain;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.time.LocalDateTime;

/**
 * 卡座对象 bst_booth
 *
 * @author ruoyi
 * @date 2025-04-18
 */
@Data
public class Booth extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long boothId;

    @Excel(name = "分区ID")
    @ApiModelProperty("分区ID")
    @NotNull(message = "分区ID不能为空",groups = ValidGroup.Create.class)
    private Long partId;

    @Excel(name = "卡座名")
    @ApiModelProperty("卡座名")
    @NotBlank(message = "卡座名不能为空",groups = ValidGroup.Create.class)
    private String boothName;

    @Excel(name = "过期时间")
    @ApiModelProperty("过期时间")
    private LocalDateTime expiredTime;

    @Excel(name = "当前使用用户ID")
    @ApiModelProperty("当前使用用户ID")
    private Long userId;

    @Excel(name = "分区图片")
    @ApiModelProperty("分区图片")
    private String picture;

    @Excel(name = "显示顺序")
    @ApiModelProperty("显示顺序")
    @NotNull(message = "显示顺序不能为空",groups = ValidGroup.Create.class)
    private Integer orderNum;

}
