package com.ruoyi.bst.device.domain;

import com.ruoyi.bst.device.domain.enums.DeviceGroupBy;
import com.ruoyi.common.valid.EnumValid;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.util.List;

@Data
public class DeviceQuery extends DeviceVO{

    @ApiModelProperty("设备id列表")
    private List<Long> deviceIds;

    @ApiModelProperty("店铺id列表")
    private List<Long> storeIds;

    @ApiModelProperty("店铺id")
    private Long storeId;

    @ApiModelProperty("MAC列表")
    private List<String> macList;

    @ApiModelProperty("卡座名称")
    private String boothName;

    @ApiModelProperty("是否查询未绑定的设备")
    private Boolean isUnbound;

    @ApiModelProperty("创建日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> createDateRange;


}
