package com.ruoyi.bst.device.domain;

import com.fasterxml.jackson.annotation.JsonView;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.domain.JsonViewProfile;
import com.ruoyi.iot.interfaces.IotDevice;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.List;

@Data
public class DeviceVO extends Device implements IotDevice {

    @Excel(name = "型号名称")
    @ApiModelProperty("型号名称")
    private String modelName;

    @Excel(name = "店铺名称")
    @ApiModelProperty("店铺名称")
    private String storeName;

    @Excel(name = "店铺ID")
    @ApiModelProperty("店铺ID")
    private Long storeId;

    @Excel(name = "商户名称")
    @ApiModelProperty("商户名称")
    private String userName;

    @Excel(name = "型号")
    @ApiModelProperty("型号")
    private String model;

    @Excel(name = "产品ID")
    @ApiModelProperty("产品ID")
    private String productId;

    @Excel(name = "投放位置")
    @ApiModelProperty("投放位置")
    private String position;

    @ApiModelProperty("型号标签列表")
    @JsonView(JsonViewProfile.App.class)
    private List<String> modelTags;

    @Override
    public String iotMac1() {
        return getMac();
    }
    @Override
    public String iotMac2() {
        return getMac2();
    }

    @Override
    public String getDeviceProductId() {
        return getProductId();
    }

}
