package com.ruoyi.bst.device.domain.dto;

import com.ruoyi.common.validRule.modelExist.ModelExist;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.util.List;

/**
 * 批量修改设备型号的请求参数
 * @author wjh
 * 2024/7/15
 */
@Data
public class DeviceBatchUpdateModelDTO {

    @ApiModelProperty("设备ID列表")
    @Size(min = 1, message = "至少需要一个设备ID")
    private List<Long> deviceIds;

    @ApiModelProperty("设备型号")
    @ModelExist(message = "设备型号不存在", allowNull = false)
    private Long modelId;

}
