package com.ruoyi.bst.device.domain.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * @author wjh
 * 2025/3/1
 */
@Data
public class DeviceWxsDTO {

    @ApiModelProperty("设备ID")
    @NotNull(message = "设备ID不允许为空")
    private Long deviceId;

    @ApiModelProperty("电量系数")
    @NotNull(message = "电量系数不允许为空")
    @DecimalMin(value = "0.02", message = "电量系数不允许小于0.02")
    @DecimalMax(value = "100", message = "电量系数不允许大于100")
    private BigDecimal wxs;
}
