package com.ruoyi.bst.model.domain;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotBlank;

/**
 * 型号列表对象 bst_model
 *
 * @author ruoyi
 * @date 2025-04-23
 */
@Data
public class Model extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long modelId;

    @Excel(name = "型号名称")
    @ApiModelProperty("型号名称")
    @NotBlank(message = "型号名称不能为空",groups = {ValidGroup.Create.class})
    private String modelName;

    @Excel(name = "型号")
    @ApiModelProperty("型号")
    @NotBlank(message = "型号不能为空",groups = {ValidGroup.Create.class})
    private String model;

    @Excel(name = "图片")
    @ApiModelProperty("图片")
    private String picture;

    @Excel(name = "产品介绍")
    @ApiModelProperty("产品介绍")
    private String introduce;

    @Excel(name = "型号标签，以逗号分隔", readConverterExp = "1=：蓝牙，2：WIFI，3：4G版，4：GPS")
    @ApiModelProperty("型号标签，以逗号分隔")
    @NotBlank(message = "型号功能不能为空",groups = {ValidGroup.Create.class})
    private String tags;

    @Excel(name = "OneNet产品ID")
    @ApiModelProperty("OneNet产品ID")
    @NotBlank(message = "OneNet产品ID不能为空",groups = {ValidGroup.Create.class})
    private String productId;

    @Excel(name = "sn前缀")
    @ApiModelProperty("sn前缀")
    private String snPrefix;

    @Excel(name = "芯片厂商")
    @ApiModelProperty("芯片厂商")
    private String chip;

}
