package com.ruoyi.bst.order.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

@Data
public class OrderQuery extends OrderVO{

    @ApiModelProperty("订单id列表")
    private List<Long> orderIds;

    @ApiModelProperty("用户id列表")
    private List<Long> userIds;

    @ApiModelProperty("下单用户")
    private String userName;

    @ApiModelProperty("商户id")
    private Long mchId;

    @ApiModelProperty("精准订单编号")
    private String eqNo;

    @ApiModelProperty("订单状态列表")
    private List<String> statusList;

    @ApiModelProperty("开始时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate beginTime;

    @ApiModelProperty("结束时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate endTime;

    @ApiModelProperty("店铺id列表")
    private List<Long> storeIds;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("关键词")
    private String keyword;

    @ApiModelProperty("结束日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> endDateRange;


    @ApiModelProperty("创建日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> createDateRange;

}
