package com.ruoyi.bst.order.domain.dto;

import com.ruoyi.bst.order.domain.vo.OrderPrePriceVO;
import com.ruoyi.common.core.interfaces.LogBizParam;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
public class OrderCreateDTO implements LogBizParam {

    @ApiModelProperty("下单用户ID")
    private Long userId;

    @ApiModelProperty("套餐ID")
    @NotNull(message = "套餐ID不能为空")
    private Long suitId;

    @ApiModelProperty("APP ID")
    @NotNull(message = "APP ID不能为空")
    private Long appId;

    @ApiModelProperty("支付渠道ID")
    @NotNull(message = "支付渠道ID不能为空")
    private Long channelId;

    @ApiModelProperty("价格信息")
    @NotNull(message = "价格信息不能为空")
    private BigDecimal payAmount;

    @ApiModelProperty("爆灯次数")
    @NotNull(message = "爆灯次数不能为空")
    private Integer number;

    @Override
    public Object logBizId() {
        return suitId;
    }
}
