package com.ruoyi.bst.part.domain;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.TreeEntity;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 分区对象 bst_part
 *
 * @author ruoyi
 * @date 2025-04-18
 */
@Data
public class Part extends TreeEntity
{
    private static final long serialVersionUID = 1L;

    private Long partId;

    @Excel(name = "店铺ID")
    @ApiModelProperty("店铺ID")
    @NotNull(message = "店铺ID不能为空",groups = ValidGroup.Create.class)
    private Long storeId;

    @Excel(name = "父区域ID")
    @ApiModelProperty("父区域ID")
    private Long parentId;

    @Excel(name = "区域名称")
    @ApiModelProperty("区域名称")
    @NotBlank(message = "区域名称不能为空",groups = {ValidGroup.Create.class})
    private String partName;

    @Excel(name = "分区图片")
    @ApiModelProperty("分区图片")
    private String picture;

    @Excel(name = "显示顺序")
    @ApiModelProperty("显示顺序")
    @NotNull(message = "显示顺序不能为空",groups = {ValidGroup.Create.class})
    private Integer orderNum;

}
