package com.ruoyi.bst.pay.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.util.List;

@Data
public class PayQuery extends PayVO {

    @ApiModelProperty("精准支付单号")
    private String eqNo;

    @ApiModelProperty("状态列表")
    private List<String> statusList;

    @ApiModelProperty("支付日期（开始）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate payDateStart;

    @ApiModelProperty("支付日期（结束）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate payDateEnd;

    @ApiModelProperty("支付日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate payDate;

    @ApiModelProperty("店铺id列表")
    private List<Long> storeIds;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("支付月份")
    private Integer payMonth;

    @ApiModelProperty("支付年份")
    private Integer payYear;

}
