package com.ruoyi.bst.refund.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;

import java.math.BigDecimal;

/**
 * 退款对象 bst_refund
 *
 * @author ruoyi
 * @date 2025-03-28
 */
@Data
public class Refund extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "退款订单编号")
    @ApiModelProperty("退款订单编号")
    private String no;

    @Excel(name = "原支付单ID")
    @ApiModelProperty("原支付单ID")
    private Long payId;

    @Excel(name = "退款金额", readConverterExp = "元=")
    @ApiModelProperty("退款金额")
    private BigDecimal amount;

    @Excel(name = "退款次数")
    @ApiModelProperty("退款次数")
    private Integer number;

    @Excel(name = "退款订单状态", readConverterExp = "R=EFUNDING退款中,S=UCCESS退款成功,F=AILED退款失败")
    @ApiModelProperty("退款订单状态")
    private String status;

    @Excel(name = "退款原因")
    @ApiModelProperty("退款原因")
    private String reason;

    @Excel(name = "退款操作人ID")
    @ApiModelProperty("退款操作人ID")
    private Long userId;

    @Excel(name = "退款操作人名称")
    @ApiModelProperty("退款操作人名称")
    private String userName;

    @Excel(name = "店铺ID")
    @ApiModelProperty("店铺ID")
    private Long storeId;

}
