package com.ruoyi.bst.refund.domain;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.util.List;

@Data
public class RefundQuery extends RefundVO {

    @ApiModelProperty("精准退款单号")
    private String eqNo;


    @ApiModelProperty("退款状态列表")
    private List<String> statusList;

    @ApiModelProperty("退款创建日期范围")
    private List<LocalDate> createDateRange;

    @ApiModelProperty("店铺ID列表")
    private List<Long> storeIds;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("月份")
    private Integer month;

    @ApiModelProperty("年份")
    private Integer year;




}
