package com.ruoyi.bst.store.domain;

import com.fasterxml.jackson.annotation.JsonView;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class StoreVO extends Store{

    // 营收相关数据拼接
    @ApiModelProperty("总订单数量")
    private Integer totalOrderCount;

    @ApiModelProperty("本日订单数量")
    private Integer todayOrderCount;

    @ApiModelProperty("总收入")
    private BigDecimal totalIncome;

    @ApiModelProperty("本月收入")
    private BigDecimal monthIncome;

    @ApiModelProperty("上月收入")
    private BigDecimal lastMonthIncome;

    @ApiModelProperty("本日收入")
    private BigDecimal todayIncome;

    @ApiModelProperty("本日退款")
    private BigDecimal todayRefundAmount;

    @ApiModelProperty("本月退款")
    private BigDecimal monthRefundAmount;

    @ApiModelProperty("上月退款")
    private BigDecimal lastMonthRefundAmount;

    // 设备相关
    @ApiModelProperty("该店铺下的设备数量")
    //@JsonView({StoreView.ListCount.class, JsonViewProfile.App.class})
    private Integer deviceCount;

    @ApiModelProperty("在线设备数量")
    private Integer onlineCount;

    @ApiModelProperty("离线设备数量")
    private Integer offlineCount;

    // 用户相关
    @ApiModelProperty("用户数量")
    private Integer totalUserCount;


}
