package com.ruoyi.bst.storeStaff.domain;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 员工运维对象 bst_store_staff
 *
 * @author ruoyi
 * @date 2025-05-15
 */
@Data
public class StoreStaff extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "店铺ID")
    @ApiModelProperty("店铺ID")
    @NotNull(message = "店铺ID不允许为空", groups = {ValidGroup.Create.class})
    private Long storeId;

    @Excel(name = "用户ID")
    @ApiModelProperty("用户ID")
    private Long userId;

    @Excel(name = "创建人ID")
    @ApiModelProperty("创建人ID")
    private Long createId;

    @Excel(name = "备注")
    @ApiModelProperty("备注")
    private String remark;

    @Excel(name = "权限列表")
    @ApiModelProperty("权限列表")
    private List<String> permissions;

}
