package com.ruoyi.bst.suit.domain;

import java.math.BigDecimal;

import com.ruoyi.common.core.validate.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * 套餐对象 bst_suit
 *
 * @author ruoyi
 * @date 2025-04-25
 */
@Data
public class Suit extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long suitId;

    @Excel(name = "商户ID")
    @ApiModelProperty("商户ID")
    private Long userId;

    @Excel(name = "店铺ID")
    @ApiModelProperty("店铺ID")
    @NotNull(message = "店铺ID不能为空",groups = {ValidGroup.Create.class})
    private Long storeId;

    @Excel(name = "充值金额", readConverterExp = "单=位：元")
    @ApiModelProperty("充值金额")
    @NotNull(message = "充值金额不能为空",groups = {ValidGroup.Create.class})
    @Min(value = 0,message = "充值金额不能小于0")
    private BigDecimal rechargeAmount;

    @Excel(name = "爆灯次数")
    @ApiModelProperty("爆灯次数")
    @NotNull(message = "爆灯次数不能为空",groups = {ValidGroup.Create.class})
    @Min(value = 0,message = "爆灯次数不能为负数")
    private Integer lightingNums;

    @Excel(name = "状态", readConverterExp = "0=正常,1=停用")
    @ApiModelProperty("状态")
    @NotNull(message = "状态不能为空", groups = {ValidGroup.Create.class})
    private String status;

    @Excel(name = "显示顺序")
    @ApiModelProperty("显示顺序")
    private Integer orderNum;

}
