package com.ruoyi.dashboard.domain.platformStat;

import com.ruoyi.common.utils.MathUtils;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Map;

@Data
public class PlatformStatVO {
    @ApiModelProperty("订单总数")
    private Integer orderCount;
    @ApiModelProperty("订单实收总金额")
    private BigDecimal orderActualAmount;
    @ApiModelProperty("订单状态数量")
    private Map<String, Integer> orderStatusCount;
    @ApiModelProperty("进行中的订单预存金额")
    private BigDecimal orderDepositAmount;

    @ApiModelProperty("支付总金额")
    private BigDecimal payAmount;
    @ApiModelProperty("退款总金额")
    private BigDecimal refundAmount;

    @ApiModelProperty("平台分成总金额")
    private BigDecimal platformBonusAmount;
    @ApiModelProperty("平台分成退款总金额")
    private BigDecimal platformBonusRefundAmount;
    @ApiModelProperty("平台分成实收")
    public BigDecimal platformBonusActualAmount() {
        return MathUtils.subtractDecimal(platformBonusAmount, platformBonusRefundAmount);
    }

    @ApiModelProperty("运营区数量")
    private Integer areaCount;

    @ApiModelProperty("设备数量")
    private Integer deviceCount;

}
