package com.ruoyi.dashboard.domain.stat;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.util.List;

@Data
public class StatQuery {

    @ApiModelProperty("日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> dateRange;

    @ApiModelProperty("订单状态列表")
    private List<String> orderStatusList;

    @ApiModelProperty("分成状态列表")
    private List<String> bonusStatusList;

    @ApiModelProperty("退款状态列表")
    private List<String> refundStatusList;

    @ApiModelProperty("是否数据隔离")
    private Boolean scope;

    @ApiModelProperty("查询数据")
    private List<String> keys;

    @ApiModelProperty("用户ID")
    private Long userId;

    @ApiModelProperty("运营区ID")
    private Long areaId;

    @ApiModelProperty("分成用户ID")
    private Long bonusUserId;

}
