package com.ruoyi.system.notice.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.common.xss.Xss;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * 通知公告表 sys_notice
 *
 * @author ruoyi
 */
@Data
public class Notice extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 公告ID */
    private Long noticeId;

    /** 公告标题 */
    @Xss(message = "公告标题不能包含脚本字符")
    @NotBlank(message = "公告标题不能为空")
    @Size(min = 0, max = 50, message = "公告标题不能超过50个字符")
    private String noticeTitle;

    /** 公告类型（1通知 2公告） */
    private String noticeType;

    /** 公告内容 */
    private String noticeContent;

    /** 公告状态（0正常 1关闭） */
    private String status;

    @Excel(name = "接收方式", readConverterExp = "1=全体用户,2=指定用户")
    @ApiModelProperty("接收方式")
    private String receiveType;

    @Excel(name = "跳转URL")
    @ApiModelProperty("跳转URL")
    private String url;

    @Excel(name = "URL类型", readConverterExp = "1=公告详情,2=小程序内部URL,3=外部URL")
    @ApiModelProperty("URL类型")
    private String urlType;

    @Excel(name = "发送方式", readConverterExp = "1=小程序内部展示,2=短信,3=公众号")
    @ApiModelProperty("发送方式")
    private String sendType;
}
