package com.ruoyi.system.user.domain;

import java.time.LocalDate;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import com.ruoyi.common.core.domain.vo.UserVO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author wjh
 * 2024/10/22
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class UserQuery extends UserVO {

    @ApiModelProperty("用户ID列表")
    private List<Long> userIds;

    @ApiModelProperty("用户名称列表")
    private List<String> userNames;

    @ApiModelProperty("用户昵称列表")
    private List<String> nickNames;

    @ApiModelProperty("精准手机号")
    private String eqPhonenumber;
 
    @ApiModelProperty("排除用户ID")
    private Long excludeUserId;

    @ApiModelProperty("排除用户ID列表")
    private List<Long> excludeUserIds;

    @ApiModelProperty("部门ID列表")
    private List<Long> deptIds;

    @ApiModelProperty("角色编码")
    private String roleKey;

    @ApiModelProperty("APP ID")
    private Long appId;

    @ApiModelProperty("精准openId")
    private String eqOpenId;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("创建日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> createDateRange;

    @ApiModelProperty("所属店铺ID")
    private Long storeId;
}
